

Imports System.Collections

Public Class SysCommonMessageBuilder
	Implements IMessageBuilder

    Private Shared messageCache As Hashtable = Hashtable.Synchronized(New Hashtable())

    ' ------------------------------------------------------- the SystemCommonMessage as a packed integer
    Private m_message As Integer = 0
    ' ------------------------------------------------------- the built SystemCommonMessage
    Private m_result As SysCommonMessage = Nothing

    Public Sub New()
        Type = SysCommonType.TuneRequest
    End Sub

    Public Sub New(ByVal message As SysCommonMessage)
        Initialize(message)
    End Sub

    Public Sub Initialize(ByVal message As SysCommonMessage)
        Me.m_message = message.Message
    End Sub

    Public Shared Sub Clear()
        messageCache.Clear()
    End Sub

    Public Shared ReadOnly Property Count() As Integer
        Get
            Return messageCache.Count
        End Get
    End Property

    ' ---------------------------------------------------------- gets the built SysCommonMessage
    Public ReadOnly Property Result() As SysCommonMessage
        Get
            Return m_result
        End Get
    End Property

    ' ---------------------------------------------------------- gets or sets the SysCommonMessage as a packed integer
    Friend Property Message() As Integer
        Get
            Return m_message
        End Get
        Set(ByVal value As Integer)
            m_message = value
        End Set
    End Property

    ' ---------------------------------------------------------- gets or sets the type of SysCommonMessage
    Public Property Type() As SysCommonType
        Get
            Return CType(ShortMessage.UnpackStatus(m_message), SysCommonType)
        End Get
        Set(ByVal value As SysCommonType)
            m_message = ShortMessage.PackStatus(m_message, value)
        End Set
    End Property

    ' ---------------------------------------------------------- gets or sets the first data value 
    Public Property Data1() As Integer
        Get
            Return ShortMessage.UnpackData1(m_message)
        End Get
        Set(ByVal value As Integer)
            m_message = ShortMessage.PackData1(m_message, value)
        End Set
    End Property

    ' ----------------------------------------------------------- gets or sets the second data value
    Public Property Data2() As Integer
        Get
            Return ShortMessage.UnpackData2(m_message)
        End Get
        Set(ByVal value As Integer)
            m_message = ShortMessage.PackData2(m_message, value)
        End Set
    End Property

    Public Sub Build() Implements IMessageBuilder.Build
        m_result = DirectCast(messageCache(m_message), SysCommonMessage)
        If m_result Is Nothing Then
            m_result = New SysCommonMessage(m_message)
            messageCache.Add(m_message, m_result)
        End If
    End Sub

End Class
