



Imports System.Diagnostics
Imports System.Collections
Imports System.Collections.Generic

Partial Public NotInheritable Class Track


    Friend Function MidiEventIterator() As IEnumerable(Of MidiEvent)
        '
        Dim Yeld_MidiEvents As List(Of MidiEvent) = New List(Of MidiEvent)
        '
        Dim current As MidiEvent = head

        While current IsNot Nothing
            ' //yield return current;
            Yeld_MidiEvents.Add(current)
            current = current.[Next]
        End While
        '
        current = endOfTrackMidiEvent
        '
        ' //yield return current;
        Yeld_MidiEvents.Add(current)
        Return Yeld_MidiEvents
    End Function




    ' YELD RETURN
    ' ================================================================================================
    ' With YELD-RETURN you can return values back to the foreach statement that called the iterator.
    ' The next time the foreach statement loops and calls the iterator again, 
    ' the iterator begins its execution where the previous yield statement left off
    ' ================================================================================================

    ' ======================================================================================
    '      TickIterator      ( YELD RETURN simulated )
    ' ======================================================================================

    Public Class Tick_Iterator

        Implements IEnumerable(Of Integer)
        Implements IEnumerator(Of Integer)

        Private startPosition As Integer
        Private chaser As ChannelChaser
        Private dispatcher As MessageDispatcher
        Private m_track As Track
        Private MidiEventEnumerator As IEnumerator(Of MidiEvent)

        Private STATUS As Int32 = 0
        Private message As IMidiMessage
        Private ticks As Integer

        Private Finished As Boolean


        Sub New(ByVal _track As Track, _
                ByVal _startPosition As Integer, _
                ByVal _chaser As ChannelChaser, _
                ByVal _dispatcher As MessageDispatcher)

            startPosition = _startPosition
            chaser = _chaser
            dispatcher = _dispatcher
            m_track = _track
            MidiEventEnumerator = m_track.MidiEventIterator().GetEnumerator()

            Finished = Not MidiEventEnumerator.MoveNext()

            While (Not Finished) AndAlso MidiEventEnumerator.Current.AbsoluteTicks < startPosition
                message = MidiEventEnumerator.Current.MidiMessage

                If message.MessageType = MessageType.Channel Then
                    chaser.Process(DirectCast(message, ChannelMessage))
                ElseIf message.MessageType = MessageType.Meta Then
                    dispatcher.Dispatch(message)
                End If

                Finished = Not MidiEventEnumerator.MoveNext()
            End While

            chaser.Chase()

            ticks = startPosition
        End Sub


        Public Function MoveNext() As Boolean Implements IEnumerator.MoveNext

            ' --------------------------------------- This strange GOTO is used to implement "Yeld Return" 
            Select Case STATUS
                Case 0
                Case 1 : GoTo Yeld_1
                Case 2 : GoTo Yeld_2
            End Select
  
            If Finished Then GoTo Exit_1
Loop_1:
            If ticks < MidiEventEnumerator.Current.AbsoluteTicks Then
Loop_2:

                STATUS = 1
                Return True
Yeld_1:
                ticks += 1
                If ticks < MidiEventEnumerator.Current.AbsoluteTicks Then GoTo Loop_2

            End If

            STATUS = 2
            Return True
Yeld_2:

            While (Not Finished) AndAlso MidiEventEnumerator.Current.AbsoluteTicks = ticks
                dispatcher.Dispatch(MidiEventEnumerator.Current.MidiMessage)
                Finished = Not MidiEventEnumerator.MoveNext()
            End While

            ticks += 1

            If Not Finished Then GoTo Loop_1

Exit_1:
            STATUS = 0
            Return True
        End Function



        Public Function GetEnumerator() As IEnumerator(Of Integer) Implements IEnumerable(Of Integer).GetEnumerator
            Return Me
        End Function

        Public Function IEnumerator_GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
            Return GetEnumerator()
        End Function



        Public ReadOnly Property Current() As Integer Implements IEnumerator(Of Integer).Current
            Get
                Return ticks
            End Get
        End Property

        Public ReadOnly Property IEnumerator_Current() As Object Implements IEnumerator.Current
            Get
                Return Current
            End Get
        End Property



        Public Sub Reset() Implements System.Collections.IEnumerator.Reset
            Throw New NotImplementedException()
        End Sub

        Private disposedValue As Boolean = False        ' To detect redundant calls

        ' IDisposable
        Protected Sub Dispose(ByVal disposing As Boolean)
            If Not Me.disposedValue Then
                If disposing Then
                    ' TODO: free other state (managed objects).
                End If

                ' TODO: free your own state (unmanaged objects).
                ' TODO: set large fields to null.
            End If
            Me.disposedValue = True
        End Sub

#Region " IDisposable Support "
        ' This code added by Visual Basic to correctly implement the disposable pattern.
        Public Sub Dispose() Implements IDisposable.Dispose
            ' Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
            Dispose(True)
            GC.SuppressFinalize(Me)
        End Sub
#End Region


    End Class



End Class